# -*- coding: utf-8 -*-
"""
Created on Tue Nov  1 09:08:18 2022

@author: pawan
"""
import numpy as np
"""
Moreau-Broto autocorrelation descriptors
"""
def calmoreaubrotodescriptors(G, mass, charge):
    n = 20
    intervalsize = 1.0
    lagL = np.array([i for i in range(0,n)]).astype(float)*intervalsize
    lagU = lagL+intervalsize
    nA = len(G)

    ATS = {}
    for kkk in range(len(lagL)):
        tempm = 0.0
        tempc = 0.0
        for i in range(nA):
            for j in range(nA):  
                if G[i,j] >= lagL[kkk] and G[i,j] < lagU[kkk]:
                    tempm = tempm + mass[i]*mass[j]
                    tempc = tempc + charge[i]*charge[j]
                else:
                    tempm = tempm + 0.0
                    tempc = tempc + 0.0
                    
        ATS['ATSm'+str(kkk+1)] = np.log(tempm/2+1)
        ATS['ATSc'+str(kkk+1)] = np.log(tempc/2+1)
    return ATS