# -*- coding: utf-8 -*-
"""
Created on Tue Nov  1 09:05:26 2022

@author: pawan
"""
import numpy as np

"""
3D MoRSE Descriptors
"""
def calmorsedescriptors(G, mass, charge):
    nA = len(G)
    n = 30
    R = np.array([i for i in range(1,n+1)]).astype(float)*1.0 # R in RDF equation
    mC = 12.011
    MoRSE = {}
    for kkk, Ri in enumerate(R):        
        tempu = 0.0
        tempm = 0.0
        tempc = 0.0
        for j in range(nA-1):
            for k in range(j+1,nA):
                tempu = tempu + np.sin(Ri*G[j,k])/(Ri*G[j,k])
                tempm = tempm + mass[j]*mass[k]*np.sin(Ri*G[j,k])/(Ri*G[j,k])
                tempc = tempc + charge[j]*charge[k]*np.sin(Ri*G[j,k])/(Ri*G[j,k])
        MoRSE['MoRSE'+'u'+str(kkk+1)] = tempu
        MoRSE['MoRSE'+'c'+str(kkk+1)] = tempc
        MoRSE['MoRSE'+'m'+str(kkk+1)] = tempm/(mC**2)
    return MoRSE