# -*- coding: utf-8 -*-
"""
Created on Tue Nov  1 09:07:05 2022

@author: pawan
"""

import numpy as np

"""
3D RDF descriptors
"""
def calrdfdescriptors(G, mass, charge):
    nA = len(G)
    beta = 100
    n = 30
    R = np.array([i for i in range(2,n+2)]).astype(float)*0.5 # R in RDF equation
    mC = 12.011
    RDF = {}
    for kkk, Ri in enumerate(R):        
        tempu = 0.0
        tempm = 0.0
        tempc = 0.0
        for j in range(nA-1):
            for k in range(j+1,nA):
                tempu = tempu + np.exp(-beta*np.power(Ri-G[j,k],2))
                tempm = tempm + mass[j]*mass[k]*np.exp(-beta*np.power(Ri-G[j,k],2))
                tempc = tempc + charge[j]*charge[k]*np.exp(-beta*np.power(Ri-G[j,k],2))
        RDF['RDF'+'u'+str(kkk+1)] = tempu
        RDF['RDF'+'c'+str(kkk+1)] = tempc
        RDF['RDF'+'m'+str(kkk+1)] = tempm/(mC**2)
    return RDF